<?php if (!defined('PmWiki')) exit();

//// ATTACHBTN & EMBEDBTN ////
## CreateAttachFileBtn() code by Patrck Michaud, from guiedit.php
## All other code by Adam Overton, 2008-2010


# Button Icon Locations
SDV($LinkBtnDir, "$PubDirUrl/embedBtns/linkbtn.gif");  # LINK BTN - for items that are Attach:'d or Download:'d, but will appear as links
SDV($EmbedBtnDir, "$PubDirUrl/embedBtns/embedbtn.gif");  # EMBED BTN - for items that are Attach:'d, but will be embedded (like images, flash, etc)
SDV($AttachBtnDir, "$PubDirUrl/embedBtns/attachbtn.gif");   # NOT CURRENTLY USED

# Sorting
SDV($attachFileBtn_imgpreg, "/(jpg|jpeg|gif|png|tif)/");
SDV($attachFileBtn_flashpreg, "/swf/");
SDV($attachFileBtn_QTvideopreg, "/(mov|mp4)/");  ## avi & flv don't currently work with quicktime
SDV($attachFileBtn_QTaudiopreg, "/(mp3|aif|aiff|au|wav|ogg)/");  

# Default Players
## don't use $group or $filename -- instead use group and filename - they will be replaced later in the function
SDV($embedBtn_audio, '\\n(:quicktime Attach:group./filename width=320 height=16 autoplay=false controller=true:)');
SDV($embedBtn_video, '\\n(:quicktime Attach:group./filename width=320 height=256 autoplay=false controller=true:)');
SDV($embedBtn_flash, '\\n(:flash Attach:group./filename width=320 height=240:)');
SDV($embedBtn_img, '\\n[[Attach:group./filename | Attach:group./filename]]');


## button to be added to attachlist, that adds each attachment to the current edit box [[Attach:myfile.jpg]]
function CreateAttachFileBtn($pagename, $AttachFileArray) {
  global $AttachFileBtn;
  $out = "<script language='javascript' type='text/javascript'>\n";
    if (!$AttachFileArray) continue;
    @list($when, $mopen, $mclose, $mtext, $tag, $mkey) = $AttachFileArray;
    if ($tag{0} == '<') { 
        $out .= "document.write(\"$tag\");\n";
        continue; 
    }
    if (preg_match('/^(.*\\.(gif|jpg|png))("([^"]+)")?$/', $tag, $m)) {
      $title = (@$m[4] > '') ? "title='{$m[4]}'" : '';
      $tag = "<img src='{$m[1]}' $title style='border:0px;' />";
    }
    $mopen = str_replace(array('\\', "'"), array('\\\\', "\\\\'"), $mopen);
    $mclose = str_replace(array('\\', "'"), array('\\\\', "\\\\'"), $mclose);
    $mtext = str_replace(array('\\', "'"), array('\\\\', "\\\\'"), $mtext);
    $out .= 
      "insButton(\"$mopen\", \"$mclose\", '$mtext', \"$tag\", \"$mkey\");\n";
  $out .= '</script>';
  return $out;
}


function AttachFileBtn_Func($filename, $pn, $embedEnabled=true) {
	#global $pagename;
	global $attachFileBtn_imgpreg, $attachFileBtn_flashpreg, $attachFileBtn_QTvideopreg, $attachFileBtn_QTaudiopreg, $LinkBtnDir, $EmbedBtnDir, $AttachBtnDir;
	global $embedBtn_audio, $embedBtn_video, $embedBtn_flash, $embedBtn_img;

	# GET GROUPNAME
	$group = PageVar($pn,'$Group');
	
	# BASIC ATTACH PREFIX
	$attachPre = "Attach:";

	# GET FILE EXTENSION
	$fileExt = strtolower(end(explode(".", $filename)));  // get the file's extension, as lowercase

	/// INSERT EMBED BTN -- ADDS [[ATTACH:]] BTN or APPROPRIATE MEDIA-PLAYER MARKUP ///
	if (preg_match($attachFileBtn_imgpreg, $fileExt)) {
		## automatically attaches image to page -- shows the image, and presents it as a link
		#$attach_btn_array = array(0, "\\n[[Attach:$group./$filename | Attach:$group./$filename]]", "", '', $EmbedBtnDir.'"embed file"');
		$attach_btn_array = array(0, str_replace(array("group","filename"), array($group,$filename), $embedBtn_img), "", '', $EmbedBtnDir.'"embed image"');
		# btnOutput
		$attachBtnCode .= CreateAttachFileBtn($pn, $attach_btn_array);

	// ADD FLASH //
	} elseif ($embedEnabled && preg_match($attachFileBtn_flashpreg, $fileExt)) {
		## automatically attaches flash to page				
		#$attach_btn_array = array(0, "\\n(:flash Attach:$group./$filename width=320 height=240:)", "", '', $EmbedBtnDir.'"embed flash"');
		$attach_btn_array = array(0, str_replace(array("group","filename"), array($group,$filename), $embedBtn_flash), "", '', $EmbedBtnDir.'"embed flash"');
		# btnOutput
		$attachBtnCode .= CreateAttachFileBtn($pn, $attach_btn_array);

	// ADD VIDEO //
	} elseif ($embedEnabled && preg_match($attachFileBtn_QTvideopreg, $fileExt)) {
		## automatically attaches movie to page				
		#$attach_btn_array = array(0, "\\n(:quicktime Attach:$group./$filename width=320 height=256 autoplay=false controller=true:)", "", '', $EmbedBtnDir.'"embed video"');
		$attach_btn_array = array(0, str_replace(array("group","filename"), array($group,$filename), $embedBtn_video), "", '', $EmbedBtnDir.'"embed video"');
		# btnOutput
		$attachBtnCode .= CreateAttachFileBtn($pn, $attach_btn_array);

	// ADD AUDIO //
	} elseif ($embedEnabled && preg_match($attachFileBtn_QTaudiopreg, $fileExt)) {
		## automatically attaches QT audio to page				
		#$attach_btn_array = array(0, "\\n(:quicktime Attach:$group./$filename width=320 height=16 autoplay=false controller=true:)", "", '', $EmbedBtnDir.'"embed audio"');
		$attach_btn_array = array(0, str_replace(array("group","filename"), array($group,$filename), $embedBtn_audio), "", '', $EmbedBtnDir.'"embed audio"');
		# btnOutput
		$attachBtnCode .= CreateAttachFileBtn($pn, $attach_btn_array);

	// LAST RESORT -- JUST USE ATTACH: //
	} else {
		## used for non-displayable stuff, like .ai, .psd, and any other non-listed format...
		$attach_btn_array = array(0, "\\n[[($attachPre$group./)$filename]]", "", '', $LinkBtnDir.'"attach file"');
		# btnOutput
		$attachBtnCode .= CreateAttachFileBtn($pn, $attach_btn_array);
	}
	
	return $attachBtnCode;
}

